#forth.inc - defines for our basic forth.

	.include "macros.inc"
	.include "reg.inc"

	.set in_buf, 0
	.set in_len, 4
	.set in_cur, 8


#exit codes
	.set OK_CODE, 0
	.set BAD_STATE_CODE, 1
	.set INPUT_END_CODE, 2
	.set ERR_CODE, 3

#Forth states
	.set INTERPRET, 0
	.set COMPILE, 1
	.set POSTPONE, 2


#offsets for variables used by the forth interpreter
	#first free space in the variables memory block
	.set var_here, -4
	.set state, -8
	.set flushed_to, -12
	#pointer to forth dictionary entries
	#pointer to first free dictionary entry
	.set forth_free, -16
	.set forth_dict, -20
	#ditto for macro (immediate) dictionary
	.set compiler_free, -24
	.set compiler_dict, -28
	#dictionary to compile into (pointer to one of the above two)
	.set current_dict, -32
	#number base
	.set base, -36
	.set first_free_var, -40

	.set D_FREE, 4
	.set D_BASE, 0

	.set DICT_ENTRY_SIZE, 16
	.set MAX_NAME_LEN, 11
	.set CODE_PTR, 12

	.macro emsg string
	.byte 0f-(.+1)  #length byte
	.byte "\string"
	.byte 10
0:
	.endm
