#some standard macros


#sections

	.macro code
	.section code, "awx", @progbits
	.align 2
	.endm

	#32-bit aligned data
	.macro data
	.section data, "awx", @progbits
	.align 2
	.endm

	#character data
	.macro cdata
	.section cdata, "awx", @progbits
	.endm

	#blank space
	.macro space
	.section space, "awx", @nobits
	.align 2
	.endm

	#initial dictionaries
	.macro dict
	.section dict, "a", @progbits
	.align 4
	.endm

	#built-in forth source code
	.macro source
	.section source, "a", @progbits
	.endm

#constants

	.set false, 0
	.set true, (~0)

#pseudo-asm instructions

	#load 32-bit immediate to a register
	.macro liw reg,value
	lis \reg,\value@ha
	addi \reg,\reg,\value@l
	.endm

	#load 32-bit unsigned immediate to a register
	.macro liwl reg,value
	lis \reg,\value@h
	ori \reg,\reg,\value@l
	.endm

	#fetch word from immediate address
	.macro lwzi reg1,reg2,value
	lis \reg2,\value@ha
	lwz \reg1,\value@l(\reg2)
	.endm

	#store word to immediate address
	.macro stwi reg1,reg2,value
	lis \reg2,\value@ha
	stw \reg1,\value@l(\reg2)
	.endm

	#fetch byte from immediate address
	.macro lbzi reg1,reg2,value
	lis \reg2,\value@ha
	lbz \reg1,\value@l(\reg2)
	.endm

	#store byte to immediate address
	.macro stbi reg1,reg2,value
	lis \reg2,\value@ha
	stb \reg1,\value@l(\reg2)
	.endm

	#test low 16 bits.
	.macro cmp0_lo reg
	clrlwi. r0,\reg,16
	.endm
