#register conventions and macros.

	.set rs, 1
	.set toc, 31
	.set ds, 13
	.set tos, 14
	.set here, 15
	.set a, 16
	#r1 - Return stack pointer, as per PPC custom.
	#
	#r31 - We have a 32KB area for variables, and a Table of
	#Contents register pointing to the top of this area (and,
	#incidentally, to the bottom of the heap).  I'm apparently
	#following the asinine SysV ABI here.  Odd.
	#
	#r13 - Forth's data stack pointer (stack grows downward).
	#
	#r14 - Top element of the data stack.
	#
	#r15 - Current heap pointer.
	#
	#r16 - Address register.

	.macro prolog
	mflr r0
	stwu r0,-4(rs)
	.endm

	.macro _epilog
	lwz r0,0(rs)
	addi rs,rs,4
	mtlr r0
	.endm

	.macro epilog
	_epilog
	blr
	.endm

	.macro tuck reg
	stwu \reg,-4(ds)
	.endm

	.macro nip reg
	lwz \reg,0(ds)
	addi ds,ds,4
	.endm

	.macro drop
	nip tos
	.endm

	.macro dup
	tuck tos
	.endm

	.macro push reg
	stwu \reg,-4(rs)
	.endm

	.macro pop reg
	lwz \reg,0(rs)
	addi rs,rs,4
	.endm
